function [res1,res2,res3,res4,res5,res6,res7,RC] = IRF(theta0)

%theta0=[theta(1),0,0,theta(2:17),0,theta(18:20),0,0,theta(21),0,theta(22:24),0,0,theta(25:28)];



cgy=theta0(1);
cmaw=theta0(2);
%cmaw= 0.8929;
cmap=theta0(3);
%cmap=0.7612;
calfa=theta0(4);
czcap=theta0(5);
csadjcost=theta0(6);
csigma=theta0(7);
chabb=theta0(8);
cfc=theta0(9);
cindw=theta0(10);
cprobw=theta0(11);
cindp=theta0(12);
cprobp=theta0(13);
csigl=theta0(14);
crpi=theta0(15);
crdy=theta0(16);
cry=theta0(17);
crr=theta0(18);
crhoa=theta0(19);
crhob=theta0(20);
%crhob=0.1926;
crhog=theta0(21);
crhoqs=theta0(22);
crhoms=theta0(23);
crhopinf=theta0(24);
%crhopinf=0.9350;
crhow=theta0(25);
%crhow= 0.9765;
sigma_a=theta0(26);
sigma_b=theta0(27);
%sigma_b= 0.2407;
sigma_g=theta0(28);
sigma_qs=theta0(29);
sigma_m=theta0(30);
sigma_pinf=theta0(31);
%sigma_pinf= 0.1358;
sigma_w=theta0(32);
%sigma_w=0.2466;
cgamma=(theta0(33)/100)+1; %note the initial parameterization as in SW Table 1a
cbeta=100/(theta0(34)+100);%
constepinf=theta0(35); %these last two enter SS only
constelab=theta0(36);

ctou=0.025; %fixed parameters as in SW
cg=0.18;
clandaw=1.5;
curvp=10;
curvw=10;
%SS parameters
cpie=1+constepinf/100;
cr=cpie/(cbeta*cgamma^(-csigma));
conster=(cr-1)*100; %r-bar for SS

order=20; %periods of IR
varind=[1:7];
res1=zeros(order+1,numel(varind));
res2=res1;
res3=res1;
res4=res1;
res5=res1;
res6=res1;
res7=res1;

count=1;

%index the variable
% Variable index: 1:consumption; 2:investment; 3:output; 4: labor
%                   5: inflation; 6: wage; 7: interest rate
%   Shock index:    1: total factor productivity
%                   2: risk premium
%                   3: spending
%                   4: investment
%                   5: monetary policy
%                   6: price markup 
%                   7: wage markup

%theta0=[theta0(1:19),theta0(21:26),theta0(28:36)];


%theta0=[theta(1:32);cgamma;cbeta;ctou;cg;clandaw;curvp;curvw];
%% Set up gensys
ssdpar;
eqvarshock;
setsimsmat; %get sims representation

%[T1,TC,T0,M,TZ,TY,GEV,RC] = gensys(GAM0,GAM1,CS,PSI,PPI);
%%
[T1,TC,T0,TY,M,TZ,TETA,GEV,RC]=gensys_mod(GAM0, GAM1, CS, PSI, PPI, 1); %use Sims-based code, also uses ordqz
 
if RC==[1;1] 

matB=eye(neq);
matA=matB(18:24,:);
A0=matA;
A1=A0*0;
A1(:,18:20)=-A0(:,18:20); %select appropriate first differences
A1(:,23)=-A0(:,23);

%%
IMP=impulse(T0,T1,A0,A1,order);
% Variable index: 1:consumption; 2:investment; 3:output; 4: labor
%                   5: inflation; 6: wage; 7: interest rate
%   Shock index:    1: total factor productivity
%                   2: risk premium
%                   3: spending
%                   4: investment
%                   5: monetary policy
%                   6: price markup 
%                   7: wage markup
% 
for l=1:numel(varind) %indexes endogenous variables

v_index=varind(l);

s_index=1;
result1=zeros(order+1,1);

for j=1:order+1
result1(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end
%%%

s_index=2;
result2=zeros(order+1,1);

for j=1:order+1
result2(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end

s_index=3;
result3=zeros(order+1,1);


for j=1:order+1
result3(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end


s_index=4;
result4=zeros(order+1,1);

for j=1:order+1
result4(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end

s_index=5;
result5=zeros(order+1,1);

for j=1:order+1
result5(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end

s_index=6;
result6=zeros(order+1,1);

for j=1:order+1
result6(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end

s_index=7;
result7=zeros(order+1,1);

for j=1:order+1
result7(j)=IMP(v_index,(j-1)*rows(IMP)+s_index);
end


res1(:,l)=result1;
%first shock, all variables
res2(:,l)=result2;
res3(:,l)=result3;
res4(:,l)=result4;
res5(:,l)=result5;
res6(:,l)=result6;
res7(:,l)=result7;

end
 
end
end

  %  [res1(:,ll),res2(:,ll),res3(:,ll),res4(:,ll),res5(:,ll),res6(:,ll),res7(:,ll)]