
% This procedure evaluates the likelihood function of the Smets and
% Wouter's model, needed for forecasting only
% As in sw, the first four periods are used as the training sample.
% Also the initial condition does not impse stationarity.
function [lvec,loglh]=evalsw_sf(TT,RR,DD0,ZZ0,Ydata,seli,M)

YY=Ydata(:,seli);
ZZ=ZZ0(seli,:);
DD=DD0(seli);

%npara  = rows(para);

nobs      = rows(YY);
loglh     = 0;
loglhzero = -1E10;
obsmean   = zeros(nobs,cols(YY));
obsvar    = zeros(nobs,cols(YY));

nstate = cols(TT);

HH = zeros(cols(YY),cols(YY));

QQ=eye(cols(RR));

RR=RR*M;

VV = zeros(cols(RR),cols(YY));

% We can now define the initial mean and variance for the state vector

At = zeros(nstate,1);
Pt = dlyap2(TT,RR*QQ*RR');
Pt=diag(diag(Pt))*2;%close
Pt=diag(diag(Pt))*0;
% compute likelihood with Kalman filter
lvec=zeros(nobs,1);

for t=1:nobs
   At1 = At;
   Pt1 = Pt;

   % Forecasting
   
   alphahat = TT*At1;
   
   if t==1
       Phat=10*eye(nstate);
   else 
   Phat = TT*Pt1*TT' + RR*QQ*RR';
   end

   yhat = ZZ*alphahat + DD;
   nu   = YY(t,:) - yhat';
   
   Ft   = ZZ*Phat*ZZ' + HH + ZZ*RR*VV + (ZZ*RR*VV)';
   Ft   = 0.5*(Ft + Ft');
   
   %forecast error variance must be non-negative, otherwise must be
   %numerical issue.
   if det(Ft)<0
       loglh=-1e10;
       %display ('negative prediction variance');
       %display (seli);
       %display (min(eig(Ft)));
       return
   end
   if t>4
   loglh = loglh -0.5*cols(YY)*log(2*pi) - 0.5*log(det(Ft)) - 0.5*nu*(Ft\nu');
  % loglh = loglh -0.5*cols(YY)*log(2*pi) - 0.5*log(det(Ft)) - 0.5*nu*inv(Ft)*nu';
   end
   lvec(t)=-0.5*cols(YY)*log(2*pi) - 0.5*log(abs(det(Ft))) - 0.5*nu*inv(Ft)*nu';
  % Updating
   
   %At = alphahat + (Phat*ZZ' + RR*VV)*inv(Ft)*nu';
   %Pt = Phat - (Phat*ZZ'+RR*VV)*inv(Ft)*(Phat*ZZ'+RR*VV)';
    At = alphahat + (Phat*ZZ' + RR*VV)*(Ft\nu');
   Pt = Phat - (Phat*ZZ'+RR*VV)*(Ft\(Phat*ZZ'+RR*VV)');

   obsmean(t,:) = yhat';
   obsvar(t,:)  = diag(Ft)';
end 

loglh=real(loglh);
end