
% This procedure filtered values "yhat" using a submodel
function fy=filt(TT,RR,DD0,ZZ0,Ydata,seli,M)

YY=Ydata(:,seli);
ZZ=ZZ0(seli,:);
DD=DD0(seli);

%npara  = rows(para);

nobs      = rows(YY);
loglh     = 0;
loglhzero = -1E10;
obsmean   = zeros(nobs,cols(YY));
obsvar    = zeros(nobs,cols(YY));

nstate = cols(TT);

HH = zeros(cols(YY),cols(YY));

QQ=eye(cols(RR));

RR=RR*M;

VV = zeros(cols(RR),cols(YY));

% We can now define the initial mean and variance for the state vector

At = zeros(nstate,1);
Pt = dlyap2(TT,RR*QQ*RR');

% compute likelihood with Kalman filter
lvec=zeros(nobs,1);
fy=zeros(nobs,cols(YY));
for t=1:nobs
   At1 = At;
   Pt1 = Pt;

   % Forecasting
   
   alphahat = TT*At1;
   Phat = TT*Pt1*TT' + RR*QQ*RR';
   

   yhat = ZZ*alphahat + DD;
   fy(t,:)=yhat;
   nu   = YY(t,:) - yhat';
   
   Ft   = ZZ*Phat*ZZ' + HH + ZZ*RR*VV + (ZZ*RR*VV)';
   Ft   = 0.5*(Ft + Ft');
   
   %forecast error variance must be non-negative, otherwise must be
   %numerical issue.
   if det(Ft)<0
       loglh=-1e10;
       %display ('negative prediction variance');
       %display (seli);
       %display (min(eig(Ft)));
       return
   end
   
   loglh = loglh -0.5*cols(YY)*log(2*pi) - 0.5*log(det(Ft)) - 0.5*nu*(Ft\nu');
  % loglh = loglh -0.5*cols(YY)*log(2*pi) - 0.5*log(det(Ft)) - 0.5*nu*inv(Ft)*nu';

   lvec(t)=-0.5*cols(YY)*log(2*pi) - 0.5*log(abs(det(Ft))) - 0.5*nu*inv(Ft)*nu';
  % Updating
   
   %At = alphahat + (Phat*ZZ' + RR*VV)*inv(Ft)*nu';
   %Pt = Phat - (Phat*ZZ'+RR*VV)*inv(Ft)*(Phat*ZZ'+RR*VV)';
    At = alphahat + (Phat*ZZ' + RR*VV)*(Ft\nu');
   Pt = Phat - (Phat*ZZ'+RR*VV)*(Ft\(Phat*ZZ'+RR*VV)');

   obsmean(t,:) = yhat';
   obsvar(t,:)  = diag(Ft)';
end 

loglh=real(loglh);
end