function foy = post_sw_6s2(theta,obsv)

YY=obsv;
theta0=[theta(1:19),0,theta(20:25),0,theta(26:34)];
ind=[1:19,21:26,28:36];


n=length(YY);
cgy=theta0(1);
cmaw=theta0(2);
%cmaw= 0.8929;
cmap=theta0(3);
%cmap=0.7612;
calfa=theta0(4);
czcap=theta0(5);
csadjcost=theta0(6);
csigma=theta0(7);
chabb=theta0(8);
cfc=theta0(9);
cindw=theta0(10);
cprobw=theta0(11);
cindp=theta0(12);
cprobp=theta0(13);
csigl=theta0(14);
crpi=theta0(15);
crdy=theta0(16);
cry=theta0(17);
crr=theta0(18);
crhoa=theta0(19);
crhob=theta0(20);
%crhob=0.1926;
crhog=theta0(21);
crhoqs=theta0(22);
crhoms=theta0(23);
crhopinf=theta0(24);
%crhopinf=0.9350;
crhow=theta0(25);
%crhow= 0.9765;
sigma_a=theta0(26);
sigma_b=theta0(27);
%sigma_b= 0.2407;
sigma_g=theta0(28);
sigma_qs=theta0(29);
sigma_m=theta0(30);
sigma_pinf=theta0(31);
%sigma_pinf= 0.1358;
sigma_w=theta0(32);
%sigma_w=0.2466;
cgamma=(theta0(33)/100)+1; %note the initial parameterization as in SW Table 1a
cbeta=100/(theta0(34)+100);%
constepinf=theta0(35); %these last two enter SS only
constelab=theta0(36);

ctou=0.025; %fixed parameters as in SW
cg=0.18;
clandaw=1.5;
curvp=10;
curvw=10;
%SS parameters
cpie=1+constepinf/100;
cr=cpie/(cbeta*cgamma^(-csigma));
conster=(cr-1)*100; %r-bar for SS

%compute parameters derived from steady state
ssdpar; %see ssdpar.m
%% 
% % number equations
eqvarshock;  %see eqvarshock.m

%%
setsimsmat; %get sims representation


if isnan(GAM0)+isinf(GAM0)==0
%[T1,TC,T0,M,TZ,TY,GEV,RC] = gensys(GAM0,GAM1,CS,PSI,PPI);
[T1,TC,T0,TY,M,TZ,TETA,GEV,RC]=gensys_mod(GAM0, GAM1, CS, PSI, PPI, 1); %use Sims-based code, also uses ordqz
 
if RC==[1;1] %%check if equilibrium exists and is unique
    
    %/*************************************************
    %       Transition equations with augmentation to allow for lags
    %       from dsge solve:   z(t) = T1*z(t-1) + T0*e(t)
    %       augmentation       x(t) = [z(t)',lags]'
    %       augmented transion x(t) = TT*x(t-1) + RR*e(t)
    %       e(t) ~ iid N(0,I)
    %*************************************************/
    nz  = cols(T1);
    nep = cols(T0);
    M=eye(nep);
    M(2,2)=0;
  
    
    %/** augmentation: lags of c, inve, y, w **/
    v_clag=nz+1;
    v_invelag=nz+2;
    v_ylag=nz+3;
    v_wlag=nz+4;

    TT = zeros(nz+4,nz+4);

    TT(1:nz,1:nz)  = T1;
    TT(v_clag,v_c) = 1;
    TT(v_invelag,v_inve) = 1;
    TT(v_ylag,v_y) = 1;
    TT(v_wlag,v_w) = 1;
    %/** augmentation: RR **/
    RR = [T0;zeros(4,nep)];
    
   

    %/*************************************************
    %       Measurment equationdy=y-y(-1)+ctrend;
    %       dc=c-c(-1)+ctrend;
    %       dinve=inve-inve(-1)+ctrend;
    %       dw=w-w(-1)+ctrend;
    %       pinfobs = 1*(pinf) + constepinf;
    %       robs =    1*(r) + conster;
    %       labobs = lab + constelab;

       %y(t) = DD + ZZ*x(t) + u(t)
    %*************************************************/
    matB=eye(nz+4);
    matB(v_c,v_clag) = -1;
    matB(v_inve,v_invelag) = -1;
    matB(v_y,v_ylag) = -1;
    matB(v_w,v_wlag) = -1;
    ZZ=matB(18:24,:);
    
    
     DD=[theta0(33)*ones(3,1);constelab;constepinf;theta0(33);conster];
   
% Variable index: 1:consumption; 2:investment; 3:output; 4: labor
%                   5: inflation; 6: wage; 7: interest rate
%   Shock index:    1: total factor productivity
%                   2: risk premium
%                   3: spending
%                   4: investment
%                   5: monetary policy
%                   6: price markup 
%                   7: wage markup

   
    %obtain the likelihood
    Ind=[1,2,3,4,5,6,7];
    foy=zeros(12,7);
    L=0;
    %vsel=nchoosek(Ind,4);
    for i=1:7%rows(vsel);
        %seli=vsel(i,:);
        
            seli=i;
        
        

        foy(:,seli)=prediction(TT,RR,DD,ZZ,YY,seli,M);
      
    end
  
 else
     foy=-1e10;  
end
else
    foy=-1e10;
  
end

   

end