function [T0,TT,RR,DD,ZZ] = scr_prep(theta0)

cgy=theta0(1);
cmaw=theta0(2);
%cmaw= 0.8929;
cmap=theta0(3);
%cmap=0.7612;
calfa=theta0(4);
czcap=theta0(5);
csadjcost=theta0(6);
csigma=theta0(7);
chabb=theta0(8);
cfc=theta0(9);
cindw=theta0(10);
cprobw=theta0(11);
cindp=theta0(12);
cprobp=theta0(13);
csigl=theta0(14);
crpi=theta0(15);
crdy=theta0(16);
cry=theta0(17);
crr=theta0(18);
crhoa=theta0(19);
crhob=theta0(20);
%crhob=0.1926;
crhog=theta0(21);
crhoqs=theta0(22);
crhoms=theta0(23);
crhopinf=theta0(24);
%crhopinf=0.9350;
crhow=theta0(25);
%crhow= 0.9765;
sigma_a=theta0(26);
sigma_b=theta0(27);
%sigma_b= 0.2407;
sigma_g=theta0(28);
sigma_qs=theta0(29);
sigma_m=theta0(30);
sigma_pinf=theta0(31);
%sigma_pinf= 0.1358;
sigma_w=theta0(32);
%sigma_w=0.2466;
cgamma=(theta0(33)/100)+1; %note the initial parameterization as in SW Table 1a
cbeta=100/(theta0(34)+100);%
constepinf=theta0(35); %these last two enter SS only
constelab=theta0(36);

ctou=0.025; %fixed parameters as in SW
cg=0.18;
clandaw=1.5;
curvp=10;
curvw=10;
%SS parameters
cpie=1+constepinf/100;
cr=cpie/(cbeta*cgamma^(-csigma));
conster=(cr-1)*100; %r-bar for SS

%compute parameters derived from steady state
ssdpar; %see ssdpar.m
%% 
% % number equations
eqvarshock;  %see eqvarshock.m

%%
setsimsmat; %get sims representation

[T1,TC,T0,TY,M,TZ,TETA,GEV,RC]=gensys_mod(GAM0, GAM1, CS, PSI, PPI, 1); %use Sims-based code, also uses ordqz
    nz  = cols(T1);
    nep = cols(T0);
   % M=eye(nep);
   % M(2,2)=0;
   % M(6,6)=0;
    %M(7,7)=0;
    
    %/** augmentation: lags of c, inve, y, w **/
    v_clag=nz+1;
    v_invelag=nz+2;
    v_ylag=nz+3;
    v_wlag=nz+4;

    TT = zeros(nz+4,nz+4);

    TT(1:nz,1:nz)  = T1;
    TT(v_clag,v_c) = 1;
    TT(v_invelag,v_inve) = 1;
    TT(v_ylag,v_y) = 1;
    TT(v_wlag,v_w) = 1;
    %/** augmentation: RR **/
    RR = [T0;zeros(4,nep)];
    
    
    matB=eye(nz+4);
    matB(v_c,v_clag) = -1;
    matB(v_inve,v_invelag) = -1;
    matB(v_y,v_ylag) = -1;
    matB(v_w,v_wlag) = -1;
    ZZ=matB(18:24,:);
    
    DD=[theta0(33)*ones(3,1);constelab;constepinf;theta0(33);conster];
    
end   
