%computes the marginal composite likelihood (not composite marginal
%likelihood)
clear;
load parasim7;
parasim=parasim7;

nv=36;
mpara=mean(parasim,1);
dpara=parasim;
parfor k=1:rows(parasim)    
dpara(k,:)=parasim(k,:)-mpara;
end

hess=dpara'*dpara/rows(parasim);
invhess=hess\eye(rows(hess));

nsim=rows(parasim);
%nsim=1000;
tau9=0.9;
tau7=0.7;
tau5=0.5;
tau1=0.1;
cut9=chi2inv(tau9,nv);
cut7=chi2inv(tau7,nv);
cut5=chi2inv(tau5,nv);
cut1=chi2inv(tau1,nv);
pp=zeros(nsim,1);
part1=pp;
f9=pp;
f7=pp;
f5=pp;
f1=pp;
dn=pp;
pp7=pp;
pp5=pp;
pp9=pp;
pp1=pp;
cer=post_sw_7(mpara);

parfor k=1:nsim
    part1(k)=(parasim(k,:)-mpara)*invhess*(parasim(k,:)-mpara)';
    dhess=(det(hess))^(-1/2);
    f9(k)=(1/cut9)*((2*pi)^(-nv/2))*dhess*exp(-part1(k)/2)*(part1(k)<cut9);
    f7(k)=(1/cut7)*((2*pi)^(-nv/2))*dhess*exp(-part1(k)/2)*(part1(k)<cut7);
    f5(k)=(1/cut5)*((2*pi)^(-nv/2))*dhess*exp(-part1(k)/2)*(part1(k)<cut5);
    f1(k)=(1/cut1)*((2*pi)^(-nv/2))*dhess*exp(-part1(k)/2)*(part1(k)<cut1);
    dn(k)=post_sw_7(parasim(k,:))-cer;
    pp9(k)=f9(k)/exp(dn(k));
    pp7(k)=f7(k)/exp(dn(k));
    pp5(k)=f5(k)/exp(dn(k));
    pp1(k)=f1(k)/exp(dn(k));
end

p9=1/mean(pp9);
p5=1/mean(pp5);
p7=1/mean(pp7);
p1=1/mean(pp1);
fp9=cer+log(p9); %-9.4059e+02
fp7=cer+log(p7); % -9.4047e+02
fp5=cer+log(p5); %-9.4010e+02
fp1=cer+log(p1); %-9.3855e+02

mg7=[fp9,fp7,fp5,fp1]
save mg7 mg7;
