% The program generates values from the quasoi posterior distribution via the random walk Metropolis Hastings Algorithm
% To utilize multiple cores, several independent chains are produced and then merged.

%% The total runtime (for 200000 draws) is about 1.9 hours on a Xeon E5-2665 single-core 2.4Ghz processor, using Matlab R2015a.

clear;
timega=tic;

lb=[0.010;0.010;0.010;0.010;0.010;2;0.250;0.0010;1;0.010;0.30;0.010;0.50;0.250;1.00;0.0010;0.0010;0.50;0.010;0.010;0.010;0.010;0.010;0.010;0.0010;0.010;0.0250;0.010;0.010;0.010;0.010;0.010;0.10;0.010;0.10;-10];
ub=[2;0.9999;0.9999;1;1;15;3;0.99000;3;0.99000;0.95000;0.99000;0.95000;10;3;0.50000;0.50000;0.97500;0.9999;0.9999;0.9999;0.9999;0.9999;0.9999;0.9999;3;5;3;3;3;3;3;0.80000;2;2;10];
lb(13)=0.1;
%ub(2)=0.9;
%ind=[1,4:19,21:23,26,28:30,33:36];
%ind=[1,3:19,21:24,26,28:31,33:36];
ind=[1:19,21:26,28:36];


lb=lb(ind);
ub=ub(ind);


%cc      = 0.07;
cc=0.1;
cc0=1;
%nblocks = 1;
nsim    = 200000;

nchain=8;

npara=34;

display ('Scaling of Hess');
display (cc);



load fhmult6;
load postmod6;
para=postmod6;
SIGSCALE=fhmult6;

simj=nsim/nchain;

numcore=8; %specify the number of cores
% 
% %for versions before R2014a
% matlabpool open local numcore
% 
% %for versions R2014a and above
ppool=parpool('local',numcore); %create parallel pool object 

ObjFunction = @post_sw_6;

parfor k=1:nchain
     mchain(ObjFunction,para,cc,cc0,SIGSCALE,lb,ub,simj,k);
     %the individual chains are saved automatically as pchain{j}
end

%% Close parallel pool

% %for versions before R2014a
% matlabpool close
% 
% %for versions R2014a and above
delete(ppool) %delete the parallel pool object 

%Now load individual files, merge them and keep only the merged file
load parasim1;
pdraws=parasim;
clear parasim;
delete parasim1.mat;


for j=2:nchain
    filename=sprintf('parasim%d.mat',j);
    load (filename);
    pdraws=[pdraws;parasim];
    clear parasim;
    delete (filename);
end 

parasim6=pdraws;
save parasim6 parasim6;
timelga=toc(timega);