
%This code produces the MSFE corresponding to for the six shocks model
%under the default specification, i.e., (6,0)
%The posterior modes for subsamples are loaded from the files already
%saved
%% The run time to obtain these posterior modes is 1-2 days on a Xeon E5-2665 8-core 2.4Ghz processor, using Matlab R2015a. 
%% The run time for this code alone is about 1 minute

clear
load sw07measurementdata
stobs=71; %starting at the same data as SW
YY=sw07dat(stobs:end,:); %remove pre-1960 data; this is the full sample
n=length(YY);
idate=100;
foy1=zeros(n,7);
foy2=zeros(n+1,7);
foy4=zeros(n+3,7);
foy8=zeros(n+7,7);
foy12=zeros(n+11,7);
er1=foy1;
er2=foy2;
er4=foy4;
er8=foy8;
er12=foy12;
vind=[1,2,3,6];
load postmod6_subq;
theta=postmod6_subq;
%for i=idate:length(postmod7_sub)
  %  temp=4*floor((i-idate)/4);
   % theta(i,:)=theta(idate+temp,:);
%end
    
%z=theta(length(theta),:);
%z=[z;z;z;z];
%theta=[theta;z];
trunc=0;
start=0;
for i=idate:(n-1)
    obsv=YY(1:i,:);
    foyi=forecast_sw_6(theta(i,:),obsv);%returning forecasting for y(t+1),y(t+2),...,y(t+12).
    foyc=cumsum(foyi);
    foy=foyi;
    foy(:,vind)=foyc(:,vind);
    
    if i<=n-1
    aoyi=YY(i+1,:);
    aoy=aoyi;
    
    er1(i+1,:)=foy(1,:)-aoy(1,:);
    end
    
    if i<=n-2
    aoyi=YY((i+1):(i+2),:);
    aoyc=cumsum(YY((i+1):(i+2),:));
    aoy=aoyi;
    aoy(:,vind)=aoyc(:,vind);
    
    er2(i+2,:)=foy(2,:)-aoy(2,:);
       
    end
    if i<=n-4
    aoyi=YY((i+1):(i+4),:);
    aoyc=cumsum(YY((i+1):(i+4),:));
    aoy=aoyi;
    aoy(:,vind)=aoyc(:,vind);
    
        er4(i+4,:)=foy(4,:)-aoy(4,:);
       
    end
    
    if i<=n-8
        aoyi=YY((i+1):(i+8),:);
    aoyc=cumsum(YY((i+1):(i+8),:));
    aoy=aoyi;
    aoy(:,vind)=aoyc(:,vind);
    
        er8(i+8,:)=foy(8,:)-aoy(8,:);
       
    end
    
    if i<=n-12
        aoyi=YY((i+1):(i+12),:);
    aoyc=cumsum(YY((i+1):(i+12),:));
    aoy=aoyi;
    aoy(:,vind)=aoyc(:,vind);
    
        er12(i+12,:)=foy(12,:)-aoy(12,:);
       
    end
end;
    
j=7;
st=idate;
z1=sqrt(mean(er1(start+idate+1:n-trunc,:).^2));

z2=sqrt(mean((er2(start+idate+2:n-trunc,:).^2)));
z4=sqrt(mean(er4(start+idate+4:n-trunc,:).^2));
z8=sqrt(mean(er8(start+idate+8:n-trunc,:).^2));

z12=sqrt(mean(er12(start+idate+12:n-trunc,:).^2));

az1=mean(abs(er1(start+idate+1:n-trunc,:)));

az2=mean(abs(er2(start+idate+2:n-trunc,:)));
az4=mean(abs(er4(start+idate+4:n-trunc,:)));
az8=mean(abs(er8(start+idate+8:n-trunc,:)));

az12=mean(abs(er12(start+idate+12:n-trunc,:)));


ord=[3,5,7,4,6,1,2];

display ('MSFE at horizons: 1, 4, and 8 quarters ahead:');
ddc=[z1(ord)',z4(ord)',z8(ord)']';
ddc=round(ddc,2);%round to the second decimal to be consistent with the table

display (ddc); 
dd6=ddc;
save dd6 dd6;