%This procedure finds the quasi posterior mode using the GA algorithm followed by multistart.
%%% The initial values are randomly generated.
%%% The mode is needed for carrying out the MCMC
%%% 07/23/2016
%% The total runtime is about 2.3 hours on a Xeon E5-2665 8-core 2.4Ghz processor, using Matlab R2015a. 


clear;

%% Objective functions and parameter bounds
ObjectiveFunction = @post_sw_6s2m; %this is the minus posterior
lb=[0.010;0.010;0.010;0.010;0.010;2;0.250;0.0010;1;0.010;0.30;0.010;0.50;0.250;1.00;0.0010;0.0010;0.50;0.010;0.010;0.010;0.010;0.010;0.010;0.0010;0.010;0.0250;0.010;0.010;0.010;0.010;0.010;0.10;0.010;0.10;-10];
ub=[2;0.990;0.990;1;1;15;3;0.99000;3;0.99000;0.95000;0.99000;0.95000;10;3;0.50000;0.50000;0.97500;0.990;0.990;0.990;0.990;0.990;0.990;0.990;3;5;3;3;3;3;3;0.80000;2;2;10];

lb(13)=0.1;

ind=[1:19,21:26,28:36];
lb=lb(ind)';
ub=ub(ind)';
numpar=length(lb);
 %% Set up parallel computation    
 numcore=8; %specify the number of cores
% 
% %for versions before R2014a
% matlabpool open local numcore
% 
% %for versions R2014a and above
ppool=parpool('local',numcore); %create parallel pool object   


%% Run optimization
    warning('off','all');
    timega=tic;
    GA_optim %run GA+Multistart
    timelga=toc(timega); %time taken by GA/Multistart
    postmod6s2=xestga2;
    save postmod6s2 postmod6s2;
 %% Close parallel pool

% %for versions before R2014a
% matlabpool close
% 
% %for versions R2014a and above
delete(ppool) %delete the parallel pool object   
  
    