%find the posterior mode using the ga algorithm followed by fmincon
%% The total run time is about 2.3 hours on a Xeon E5-2665 8-core 2.4Ghz processor, using Matlab R2015a. 

clear

%% Objective functions and parameter bounds
warning('off','all')
ObjectiveFunction = @post_sw_7s2m; %this is the minus posterior
lb=[0.010;0.010;0.010;0.010;0.010;2;0.250;0.0010;1;0.010;0.30;0.010;0.50;0.250;1.00;0.0010;0.0010;0.50;0.010;0.010;0.010;0.010;0.010;0.010;0.0010;0.010;0.0250;0.010;0.010;0.010;0.010;0.010;0.10;0.010;0.10;-10]';
ub=[2;0.990;0.990;1;1;15;3;0.99000;3;0.99000;0.95000;0.99000;0.95000;10;3;0.50000;0.50000;0.97500;0.990;0.990;0.990;0.990;0.990;0.990;0.990;3;5;3;3;3;3;3;0.80000;2;2;10]';

%lb(11)=0.5;%this is used only to help convergence
lb(13)=0.1;
ind=[1:36];

numpar=length(lb);
 %% Set up parallel computation    
 numcore=8; %specify the number of cores
% 
% %for versions before R2014a
% matlabpool open local numcore
% 
% %for versions R2014a and above
ppool=parpool('local',numcore); %create parallel pool object   


%% Run optimization
    timega=tic;
   
    GA_optim %run GA+Multistart
    timelga=toc(timega); %time taken by GA/Multistart
    postmod7s2=xestga2;
    save postmod7s2 postmod7s2;
 %% Close parallel pool

% %for versions before R2014a
% matlabpool close
% 
% %for versions R2014a and above
delete(ppool) %delete the parallel pool object   
  
    