% Description: The program computes the hessian at the mode
%translated from Lubik and Schorfheide's (2004,AER) gauss code sunhess.src; 09/20/01
%% Computational time: 22 minutes on a Xeon E5-2665 8-core 2.4Ghz processor, using Matlab R2015a. 

load('postmod7s2.mat');
para=postmod7s2;
npara=length(para); %number of parameters
ndx = 6; %different step sizes
seq= [6,8,10,12,14,16];
dx =  exp(-seq);
hessian = zeros( npara, npara );
gradx = zeros(ndx,1);%store the gradients
grady = zeros(ndx,1);
gradxy = zeros(ndx,1);
hessdiag = zeros(ndx,1);

dxscale=ones(npara,1);
timega=tic;
% Compute Diagonal elements first
for seli=1:npara
    parfor i=1:ndx
      paradx = para;
      parady = para;
      paradx(seli)= paradx(seli) + dx(i)*dxscale(seli);
      parady(seli) = parady(seli) - dx(i)*dxscale(seli);
      paradxdy = paradx;
      paradxdy(seli) = paradxdy(seli) - dx(i)*dxscale(seli);
      fx  = post_sw_7s2(para);
      fdx = post_sw_7s2(paradx);
      fdy = post_sw_7s2(parady);
      fdxdy = post_sw_7s2(paradxdy);
      gradx(i) = -( fx - fdx )/ (dx(i)*dxscale(seli));
      grady(i) = ( fx - fdy )/ (dx(i)*dxscale(seli));
      gradxy(i) = -(fx -fdxdy)/ sqrt( (dx(i)*dxscale(seli))^2 + (dx(i)*dxscale(seli))^2 );
      hessdiag(i) = -( 2*fx - fdx - fdy)/(dx(i)*dxscale(seli))^2; 
      hessdiag(i) = -( fx - fdx - fdy + fdxdy )/(dx(i)*dx(i)*dxscale(seli)*dxscale(seli));
    end
    display ('values');
    display(-hessdiag');
     hessian(seli,seli) = -0.5*(hessdiag(3)+hessdiag(4));
    display ('value used');
    display (hessian(seli,seli));
end

% Now compute off-diagonal elements
% Make sure that correlations are between -1 and 1
% errorij contains the index of elements that are invalid
%
errorij = [0,0,0];

for seli=1:(npara-1)
    for selj=(seli+1):npara
     parfor i=1:ndx
      paradx = para;
      parady = para;
      paradx(seli) = paradx(seli) + dx(i)*dxscale(seli);
      parady(selj) = parady(selj) - dx(i)*dxscale(selj);
      paradxdy = paradx;
      paradxdy(selj) = paradxdy(selj) - dx(i)*dxscale(selj);
      fx  = post_sw_7s2(para);
      fdx = post_sw_7s2(paradx);
      fdy = post_sw_7s2(parady);
      fdxdy = post_sw_7s2(paradxdy);
      gradx(i) = -( fx - fdx )/ (dx(i)*dxscale(seli));
      grady(i) = ( fx - fdy )/ (dx(i)*dxscale(selj));
      gradxy(i) = -(fx -fdxdy)/ sqrt( (dx(i)*dxscale(selj))^2 + (dx(i)*dxscale(seli))^2 );
      hessdiag(i) = -( 2*fx - fdx - fdy)/(dx(i)*dxscale(seli))^2; 
      hessdiag(i) = -( fx - fdx - fdy + fdxdy )/(dx(i)*dx(i)*dxscale(seli)*dxscale(selj));
     end
  

     hessian(seli,selj) = -0.5*(hessdiag(3)+hessdiag(4));
     
     if ( hessian(seli,seli) == 0 ) | (hessian(selj,selj) == 0)
        corrij = 0;
     else
        corrij = hessian(seli,selj)/sqrt(hessian(seli,seli)*hessian(selj,selj));
     end

     if (corrij < -0.98) | (corrij > 0.98);
        hessian(seli,selj)=0.9*sqrt(hessian(seli,seli)*hessian(selj,selj));
        errorij = [errorij;seli,selj,corrij];
     elseif (corrij > -0.005) & (corrij < 0.005)
        hessian(seli,selj)=0;
     end   
     hessian(selj,seli) = hessian(seli,selj);
     
     display('value used');
     %display (hessian(seli,selj));
     display ('correlation');
     display (corrij);
     display ('number of errors');
     display (rows(errorij)-1);
    end
end

display ('errors');
display (errorij);

hessian7s2=hessian;

save hessian7s2 hessian7s2


% Load Hessian, compute penalty

HHm   = hessian;
%if determinacy==1
 %   rankHHM=npara-4;
%else
    rankHHM=npara;
%end

% Create Inverse by Singular Value Decomposition
%
[u , s, v] = svd(HHm);
invHHMdet = 1;
for i=1:npara
   if i > rankHHM
      s(i,i) = 0;
   else
      s(i,i)    = 1/s(i,i);
      invHHMdet = invHHMdet*s(i,i);
   end
end
invHHM  = u*s*u';
fhmult = u*sqrt(s);

display ('Determinant of minus inverse Hessian');
display(invHHMdet);
display ('sqrt(Diagonal of Inverse Hessian)');
display(sqrt(diag(invHHM)));

display ('Post Mode Penalty');
penalt = (rankHHM/2)*log(2*pi) + 0.5*log(invHHMdet);
display(penalt);
fhmult7s2=fhmult;

save fhmult7s2 fhmult7s2;
timelga=toc(timega);

