%%% Computes the mcmc and asymptotic intervals using the draws
%%% The computational time is about 1 minute.
clear;
load parasim2;
parasim=parasim2;
load postmod2;
lb=[1E-5 1E-5 1E-5 1.00001  1E-5  1E-5  1E-5  1E-5   1E-5 1E-5 -0.999  1E-5 ]';
ub=[100   100   100  10   0.999 0.999 0.999 0.999  10      10   0.999  10 ]';
    
    
ndraw=rows(parasim);
mpara=mean(parasim,1);
clevel=0.95;
cv1=floor(ndraw*(1-clevel));
cv2=floor(ndraw*clevel);
spara=parasim;
for j=1:12
   tempv=sort(parasim(:,j)); 
   spara(:,j)=tempv;
end

display ('--Parameter order: 1/tau rstar kappa psi1 psi2 rhoR rhog rhoz sigg sigz, rhogz, pistar--');

display('-- 90% mcmc intervals:-----');
display([spara(cv1,:);spara(cv2,:)]');


dpara=spara;
for j=1:rows(parasim)
    
dpara(j,:)=parasim(j,:)-mpara;
end


%load hessian;
score = score_2(postmod2);

invhess=dpara'*dpara/rows(dpara);
[v,d] = svd(invhess);
d=inv(d);
H12 = v*sqrt(d)*v';
[v,d] = svd(score);
S12 = v*sqrt(d)*v';
newpara=invhess*S12*H12*dpara';
newpara=newpara';
center=mpara(ones(ndraw,1),:);
draw1=newpara+center;

for j=1:12
   tempv=sort(newpara(:,j)); 
   spara(:,j)=tempv;
end
display('-- 90% asymptotic intervals:-----');
display([max(spara(cv1,:)+mpara,lb');min(spara(cv2,:)+mpara,ub')]');

%sand=invhess*score*invhess;
%dsand=sqrt(diag(sand));
%display ([max(mpara-1.645*dsand',lb');min(mpara+1.645*dsand',ub')]');
draw2=draw1;  
save draw2 draw2;    
