%%% The procedure finds the mode of the quasi posterior using the ga algorithm followed by fmincon
%%% The initial values are randomly generated.
%%% The mode is need for carrying out the MCMC
%%% 07/16/2016

%% The total runtime is about 8.0 minutes on a Xeon E5-2665 8-core 2.4Ghz processor, using Matlab R2015a. 


clear
%% the objective function for minimization
ObjectiveFunction = @ls_ps_3m; 

%% parameter lower and upper bounds
%[1/tau rstar kappa psi1 psi2 rhoR rhog rhoz sigR sigg sigz, rhogz, pistar]';
    lb=[0.1 1 0.1 1.1  0.1  0.1  0.1  0.1   0.01  0.01 0.01 -0.9  2 ];
    ub=[3   4   1  5 0.99 0.90 0.99 0.99   3  3    3   0.9  5 ];
 %% Set up parallel computation    
 numcore=8; %specify the number of cores
% 
% %for versions before R2014a
% matlabpool open local numcore
% 
% %for versions R2014a and above
ppool=parpool('local',numcore); %create parallel pool object    

%% Run optimization
timega=tic;
options=gaoptimset;
options = gaoptimset(options,'Generation',5000,'PopulationSize',200,'UseParallel','Always');
options = gaoptimset(options,'Display','iter','StallGenLimit',50);
[xest,fval,exitflag,output,population,scores]=ga(ObjectiveFunction,13,[],[],[],[],lb,ub,[],options);
options = gaoptimset(options,'Generations',10000,'InitialPopulation',population(1:64,:),'PopulationSize',64);
[xest,fval,exitflag,output,population,scores]=ga(ObjectiveFunction,13,[],[],[],[],lb,ub,[],options);
option2 = optimset('fmincon');
option2=optimset(option2,'Algorithm','interior-point','Display','iter','MaxFunEvals', 1e10,'TolFun',1e-10,'TolCon',1e-10);
[xest2,fval,exitflag,output] = fmincon(ObjectiveFunction,xest,[],[],[],[],lb,ub,[],option2);
timelga=toc(timega);

%% Close parallel pool

% %for versions before R2014a
% matlabpool close
% 
% %for versions R2014a and above
delete(ppool) %delete the parallel pool object  

%% Display and save results
postmod3=xest2;
%save postmod postmod;
disp '--------The mode is at:-------- '
disp('[1/tau rstar kappa psi1 psi2 rhoR rhog rhoz sigR sigg sigz, rhogz, pistar]');
 
disp(xest2);
save postmod3 postmod3;

 
  

    