%06/14/2013
%This function computes the log quasi posterior

function X = ls_ps_1(para)

%parameter order:
%[1/tau rstar kappa psi1 psi2 rhoR rhog rhoz sigR sigg sigz, rhogz, pistar]';

load datax;
x0=datax; 
f_para=[para(1:6),0,para(7),0,0,para(8),0,para(9)];
%add zeros for parameters that do not appear in the submodel. This is not
%necessary in application. But this allows us to use the same model
%solution procedure for all the models.
inds=[1:6,8,11,13];
%% solve the model

[TT,TC,TEPS,TETA,RC] = lubiksolv(f_para);
if isempty(TT)
    disp('empty solution: nonexistence/numerical issue') 
    X=-1E10;
    return
end

neq=cols(TT); %number of equations

M=[0,0,0;0,0,0;0,0,1];

if RC==[1;1]
    sel1=[1,0,0];
    sel2=[0,1,0];
    sel3=[0,0,1];
   [lvec,loglh1,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel1,M);
   [lvec,loglh2,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel2,M);
   [lvec,loglh3,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel3,M);
    L=loglh1+loglh2+loglh3;
    lp=logprls(para,inds); %compute log prior density
    %inds indicates parameters in the singular model relative to the full
    %model. This is not necessary, but allows us to use the same prior
    %function for different singular models.
    X=L+lp; 
else
    X=-1E10;
end
end