%07/17/2016
%This function computes log quasi posterior of the two shocks model
%The structure is the same as ls_ps_1.m

function X = ls_ps_2(para)

%parameter order:
%[1/tau rstar kappa psi1 psi2 rhoR rhog rhoz sigR sigg sigz, rhogz, pistar]';

load datax;
x0=datax; 
f_para=[para(1:8),0,para(9:12)];
%add zeros for parameters that do not appear in the submodel. This is not
%necessary in application. But this allows us to use the same model
%solution procedure for all models.
inds=[1:8,10:13];
%% solve the model

[TT,TC,TEPS,TETA,RC] = lubiksolv(f_para);
if isempty(TT)
    disp('empty solution: nonexistence/numerical issue') 
    X=-1E10;
    return
end

neq=cols(TT); %number of equations

M=[0,0,0;0,1,0;0,0,1];

if RC==[1;1]
    sel1=[0,1,0];
    sel2=[1,0,0;0,0,1];
   [lvec,loglh1,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel1,M);
   [lvec,loglh2,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel2,M);
   
    L=loglh1+loglh2;
    lp=logprls(para,inds); %compute log prior density
    %inds indicates parameters in the singular model relative to the full
    %model. This is not necessary, but allows us to use the same prior
    %function for different singular models.
    X=L+lp; 
else
    X=-1E10;
end
end