function score = score_1(para)

%load('postmod.mat'); 
load datax;
x0=datax; 
%para=postmod;
dims=size(x0);

f_para=[para(1:6),0,para(7),0,0,para(8),0,para(9)];
%add zeros for parameters that do not appear in the submodel. This is not
%necessary in application. But this allows us to use the same model
%solution procedure for all models.
%% solve the model

[TT,TC,TEPS,TETA,RC] = lubiksolv(f_para);
if isempty(TT)
    disp('empty solution: nonexistence/numerical issue') 
    score=-1E10;
    return
end
M=[0,0,0;0,0,0;0,0,1];


sel1=[1,0,0];
sel2=[0,1,0];
sel3=[0,0,1];
[lvec1,loglh1,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel1,M);
[lvec2,loglh2,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel2,M);
[lvec3,loglh3,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel3,M);
lvec=lvec1+lvec2+lvec3;
     
nloglh=zeros(rows(lvec),9);
j=1;
for j=1:9
npara=para;
npara(j)=para(j)+para(j)*1e-6;
nf_para=[npara(1:6),0,npara(7),0,0,npara(8),0,npara(9)];
[TT,TC,TEPS,TETA,RC] = lubiksolv(nf_para);
if isempty(TT)
    disp('empty solution: nonexistence/numerical issue') 
    score=-1E10;
    return
end
[lvec1,loglh1,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,nf_para,x0,sel1,M);
[lvec2,loglh1,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,nf_para,x0,sel2,M);
[lvec3,loglh1,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,nf_para,x0,sel3,M);
nlvec=lvec1+lvec2+lvec3;
nloglh(:,j)=(nlvec-lvec)/(para(j)*1e-6);
     
end

%S=nloglh'*nloglh;

score=cov(nloglh)*dims(1);
save score score;
end


