function score = score_2(para)

%load('postmod2.mat'); 
load datax;
x0=datax; 
%para=postmod2;
dims=size(x0);
%[1/tau rstar kappa psi1 psi2 rhoR rhog rhoz sigR sigg sigz, rhogz, pistar]';
f_para=[para(1:8),0,para(9:12)];
%add zeros for parameters that do not appear in the submodel. This is not
%necessary in application. But this allows us to use the same model
%solution procedure for all models.
%% solve the model

[TT,TC,TEPS,TETA,RC] = lubiksolv(f_para);
if isempty(TT)
    disp('empty solution: nonexistence/numerical issue') 
    score=-1E10;
    return
end
M=[0,0,0;0,1,0;0,0,1];


sel1=[0,1,0];
sel2=[1,0,0;0,0,1];

[lvec1,loglh1,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel1,M);
[lvec2,loglh2,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,f_para,x0,sel2,M);

lvec=lvec1+lvec2;
     
nloglh=zeros(rows(lvec),12);
j=1;
for j=1:12
npara=para;
npara(j)=para(j)+para(j)*1e-6;
nf_para=[npara(1:8),0,npara(9:12)];
[TT,TC,TEPS,TETA,RC] = lubiksolv(nf_para);
if isempty(TT)
    disp('empty solution: nonexistence/numerical issue') 
    score=-1E10;
    return
end
[lvec1,loglh1,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,nf_para,x0,sel1,M);
[lvec2,loglh1,retcode,obsmean,obsvar]=evalcgg_s(TT,TC,TEPS,TETA,RC,nf_para,x0,sel2,M);

nlvec=lvec1+lvec2;
nloglh(:,j)=(nlvec-lvec)/(para(j)*1e-6);
     
end

%S=nloglh'*nloglh;

score=cov(nloglh)*dims(1);
score2=score;
save score2 score2;
end


